Loading...
Searching...
No Matches
QGpgME::SignJob Class Referenceabstract

An abstract base class for asynchronous signing. More...

`#include <signjob.h>`

Inheritance diagram for QGpgME::SignJob:
[legend]
Collaboration diagram for QGpgME::SignJob:
[legend]

## Signals

void | result (const GpgME::SigningResult &result, const QByteArray &signature, const QString &auditLogAsHtml=QString(), const GpgME::Error &auditLogError=GpgME::Error())
Signals inherited from QGpgME::Job
void | jobProgress (int current, int total)
void | rawProgress (const QString &what, int type, int current, int total)
QGPGME_DEPRECATED void | progress (const QString &what, int current, int total)
void | done ()

## Public Member Functions

void | setSigners (const std::vector< GpgME::Key > &signers)
std::vector< GpgME::Key > | signers () const
void | setInputFile (const QString &path)
QString | inputFile () const
void | setOutputFile (const QString &path)
QString | outputFile () const
void | setSigningFlags (GpgME::SignatureMode flags)
GpgME::SignatureMode | signingFlags () const
void | setAppendSignature (bool append)
bool | appendSignatureEnabled () const
virtual GpgME::Error | start (const std::vector< GpgME::Key > &signers, const QByteArray &plainText, GpgME::SignatureMode mode)=0
virtual void | start (const std::vector< GpgME::Key > &signers, const std::shared_ptr< QIODevice > &plainText, const std::shared_ptr< QIODevice > &signature, GpgME::SignatureMode mode)=0
virtual GpgME::SigningResult | exec (const std::vector< GpgME::Key > &signers, const QByteArray &plainText, GpgME::SignatureMode mode, QByteArray &signature)=0
virtual void | setOutputIsBase64Encoded (bool)=0
Public Member Functions inherited from QGpgME::Job
virtual QString | auditLogAsHtml () const
virtual GpgME::Error | auditLogError () const
bool | isAuditLogSupported () const
GpgME::Error | startIt ()
void | startNow ()

## Protected Member Functions

| SignJob (std::unique_ptr< SignJobPrivate >, QObject *parent)
Protected Member Functions inherited from QGpgME::Job
| Job (std::unique_ptr< JobPrivate >, QObject *parent)
| Job (QObject *parent)

## Additional Inherited Members

Public Slots inherited from QGpgME::Job
virtual void | slotCancel ()=0
Static Public Member Functions inherited from QGpgME::Job
static GpgME::Context * | context (Job *job)
Protected Attributes inherited from QGpgME::Job
const std::unique_ptr< JobPrivate > | d_ptr

## Detailed Description

An abstract base class for asynchronous signing.

To use a SignJob, first obtain an instance from the CryptoBackend implementation, connect the progress() and result() signals to suitable slots and then start the signing with a call to start(). This call might fail, in which case the SignJob instance will have scheduled it's own destruction with a call to QObject::deleteLater().

Alternatively, the job can be started with startIt() after setting an input file and an output file and, optionally, signers or flags. If the job is started this way then the backend reads the input and writes the output directly from/to the specified input file and output file. In this case the signature value of the result signal will always be empty. This direct IO mode is currently only supported for OpenPGP. Note that startIt() does not schedule the job's destruction if starting the job failed.

After result() is emitted, the SignJob will schedule it's own destruction by calling QObject::deleteLater().

## Member Function Documentation

## setAppendSignature()

void SignJob::setAppendSignature | ( | bool | append | ) |

If `true` then a new detached signature is appended to an already existing detached signature.

Defaults to `false`.

Used if the job is started with startIt().

## setInputFile()

void SignJob::setInputFile | ( | const QString & | path | ) |

Sets the path of the file to sign.

Used if the job is started with startIt().

## setOutputFile()

void SignJob::setOutputFile | ( | const QString & | path | ) |

Sets the path of the file to write the signing result to.

Used if the job is started with startIt().

Note
  If a file with this path exists, then the job will fail, i.e. you need to delete an existing file that shall be overwritten before you start the job. If you create a detached signature then you can tell the job to append the new detached signature to an existing file.

## setOutputIsBase64Encoded()

virtual void QGpgME::SignJob::setOutputIsBase64Encoded | ( | bool |  | ) |

pure virtual

This is a hack to request BASE64 output (instead of whatever comes out normally).

Implemented in QGpgME::QGpgMESignJob.

## setSigners()

void SignJob::setSigners | ( | const std::vector< GpgME::Key > & | signers | ) |

Sets the keys to use for signing.

Used if the job is started with startIt().

## setSigningFlags()

void SignJob::setSigningFlags | ( | GpgME::SignatureMode | flags | ) |

Sets the flags to use for signing.

Defaults to `SignFile`.

Used if the job is started with startIt(). The `SignFile` flag is always assumed set.

## start() [1/2]

virtual GpgME::Error QGpgME::SignJob::start | ( | const std::vector< GpgME::Key > & | signers,
|  | const QByteArray & | plainText,
|  | GpgME::SignatureMode | mode )

pure virtual

Starts the signing operation. signers is the list of keys to sign plainText with. Empty (null) keys are ignored.

Implemented in QGpgME::QGpgMESignJob.

## start() [2/2]

virtual void QGpgME::SignJob::start | ( | const std::vector< GpgME::Key > & | signers,
|  | const std::shared_ptr< QIODevice > & | plainText,
|  | const std::shared_ptr< QIODevice > & | signature,
|  | GpgME::SignatureMode | mode )

pure virtual

This is an overloaded member function, provided for convenience. It differs from the above function only in what argument(s) it accepts.

If signature is non-null the signature is written there. Otherwise, it will be delivered in the second argument of result().

Implemented in QGpgME::QGpgMESignJob.

The documentation for this class was generated from the following files:

- signjob.h
- signjob.cpp